/*
 * /////////////////////////////////////////////////////////////////////////////
 * // This file is part of the "Hyrax Data Server" project.
 * //
 * //
 * // Copyright (c) 2017 OPeNDAP, Inc.
 * // Author: Uday Kari  <ukari@opendap.org>
 * //
 * // This library is free software; you can redistribute it and/or
 * // modify it under the terms of the GNU Lesser General Public
 * // License as published by the Free Software Foundation; either
 * // version 2.1 of the License, or (at your option) any later version.
 * //
 * // This library is distributed in the hope that it will be useful,
 * // but WITHOUT ANY WARRANTY; without even the implied warranty of
 * // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * // Lesser General Public License for more details.
 * //
 * // You should have received a copy of the GNU Lesser General Public
 * // License along with this library; if not, write to the Free Software
 * // Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 * //
 * // You can contact OPeNDAP, Inc. at PO Box 112, Saunderstown, RI. 02874-0112.
 * /////////////////////////////////////////////////////////////////////////////
 */

package opendap.dap4;


import javax.xml.bind.annotation.*;

/**
 * JAXB spec for Dimension elements of DMR
 *   
 */
public class Dimension {
	
	private String name = "";
	private String size = "";
	
	
	@XmlAttribute
	public String getName() {
		return name;
	}
	
	
	public void setName(String name) {
		this.name = name;
	}
	
	@XmlAttribute
	public String getSize() {
		return size;
	}
	public void setSize(String size) {
		this.size = size;
	}

	public long getSizeAsLong(){
		long value = -1;
		try {
			value = Long.parseLong(getSize());
		}
		catch (NumberFormatException nfe){
		}
		return value;

	}
	
	public String toString()
	{
		return "Dimension name = " + name + ", size = " + size;
	}

}
